#!/usr/bin/python
#
# File: soapserver.py
# (c) 2006 Jan Dittberner <jan@dittberner.info>
# $Id$
#
from SOAPpy import SOAPServer
import logging

class GnuviechAdminSOAPServer:
    """
    SOAP Server class for the gnuviech administration tool backend
    """
    def echo(self, s):
        self.logger.debug("calling echo with " + s)
        #(sock, address) = self.server.get_request()
        #self.logger.debug("socket " + sock)
        #self.logger.debug("address" + address)
        return s + s
    
    def __init__(self):
        self.logger = logging.getLogger('GnuviechAdminSOAPServer')
        hdlr = logging.FileHandler('soapserver.log')
        hdlr.setFormatter(logging.Formatter('%(asctime)s %(levelname)s %(message)s'))
        self.logger.addHandler(hdlr)
        self.logger.setLevel(logging.DEBUG)
        self.server = SOAPServer(("127.0.0.1", 8080))
        self.logger.debug("created SOAPServer")
        self.server.registerFunction(self.echo)
        self.logger.debug("registered function echo")
        
    def main(self):
        self.logger.debug("serving SOAP")
        self.server.serve_forever()
        
if __name__ == "__main__":
    server = GnuviechAdminSOAPServer()
    server.main()